package com.simple.plugin.signDemo;

import android.annotation.SuppressLint;
import android.content.Context;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Path;
import android.graphics.PorterDuff;
import android.net.Uri;
import android.os.Environment;
import android.text.TextUtils;
import android.util.AttributeSet;
import android.view.MotionEvent;
import android.view.View;

import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.UUID;

public class SignatureView extends View {
    //画笔宽度
    public static final int PEN_WIDTH = 10;
    //画笔颜色
    public static final int PEN_COLOR = Color.BLACK;
    //画板颜色
    public static final int BACK_COLOR = Color.WHITE;

    //画笔x坐标起点
    private float mPenX;
    //画笔y坐标起点
    private float mPenY;
    private Paint mPaint = new Paint();
    private Path mPath = new Path();
    private Canvas mCanvas;
    private Bitmap cacheBitmap;
    private boolean isTouched = false;
    private String mSavePath = null;
    public SignatureView(Context context) {
        this(context, null);
    }

    public SignatureView(Context context, AttributeSet attrs) {
        this(context, attrs, 0);
    }

    public SignatureView(Context context, AttributeSet attrs, int defStyleAttr) {
        super(context, attrs, defStyleAttr);
//        TypedArray typedArray = context.obtainStyledAttributes(attrs, R.styleable.SignatureView);//拿到样式集合
//        //画笔颜色
//        PEN_COLOR = typedArray.getColor(R.styleable.SignatureView_penColor, PEN_COLOR);
//        //画板颜色
//        BACK_COLOR = typedArray.getColor(R.styleable.SignatureView_backColor, BACK_COLOR);
//        //画笔宽度
//        PEN_WIDTH = typedArray.getInt(R.styleable.SignatureView_penWidth, PEN_WIDTH);
//        typedArray.recycle();//回收资源
        init();
    }

    private void init() {
        mPaint.setAntiAlias(true);//抗锯齿
        mPaint.setStyle(Paint.Style.STROKE);//描边
        mPaint.setStrokeWidth(PEN_WIDTH);//设置画笔宽度
        mPaint.setColor(PEN_COLOR); //设置画笔颜色  black
    }

    public boolean getTouched() {
        return isTouched;
    }

//    public void setPentWidth(int pentWidth) {
//        PEN_WIDTH = pentWidth;
//    }
//
//    public void setPenColor(@ColorInt int penColor) {
//        PEN_COLOR = penColor;
//    }
//
//    public void setBackColor(@ColorInt int backColor) {
//        BACK_COLOR = backColor;
//    }

    /**
     * 清空签名
     */
    public void clear() {
        if (mCanvas != null) {
            isTouched = false;
            mCanvas.drawColor(Color.TRANSPARENT, PorterDuff.Mode.CLEAR);//清除画布内容
            mCanvas.drawColor(BACK_COLOR);//重新设置画布颜色
            invalidate();
        }
    }

    /**
     * 保存图片
     *
     * @param path 保存的地址
     * @param clearBlank 是否清除空白区域
     * @param blank 空白区域留空距离
     * @throws
     */
    public void save(String path, boolean clearBlank, int blank, Context context,String bs) throws IOException {
        if (TextUtils.isEmpty(path)) {
            return;
        }
        mSavePath = path;
        Bitmap bitmap = cacheBitmap;
        saveFile(context,bitmap,bs);
//        if (clearBlank) {
//            bitmap = clearBlank(bitmap, blank);
//        }
//        ByteArrayOutputStream bos = new ByteArrayOutputStream();
//        bitmap.compress(Bitmap.CompressFormat.PNG, 100, bos);
//        byte[] buffer = bos.toByteArray();
//        if (buffer != null) {
//            File file = new File(path);
//            if (file.exists()) {
//                file.delete();
//            }
//            OutputStream os = new FileOutputStream(file);
//            os.write(buffer);
//            os.close();
//            bos.close();
//        }
    }

    @SuppressLint("WrongThread")
    public  void saveFile(Context context, Bitmap bm, String bs) throws IOException {

        String fileName = UUID.randomUUID().toString() + ".jpg";
        //0；存到相册 1；沙盒
        if (bs.equals("1")){
            File dirFile = new File(context.getFilesDir().getAbsolutePath()+ File.separator+ "SUPCON");
            if (!dirFile.exists()) {
                dirFile.mkdir();
            }
            File myCaptureFile = new File(dirFile + File.separator+ fileName);
            mSavePath=myCaptureFile.getPath();
            BufferedOutputStream bos = new BufferedOutputStream(new FileOutputStream(myCaptureFile));
            bm.compress(Bitmap.CompressFormat.JPEG, 80, bos);
            bos.flush();
            bos.close();
        }else {
            File dirFile = new File(Environment.getExternalStorageDirectory().getPath());
            if (!dirFile.exists()) {
                dirFile.mkdir();
            }
            File myCaptureFile = new File(Environment.getExternalStorageDirectory().getPath() + "/DCIM/Camera/" + fileName);
            mSavePath=myCaptureFile.getPath();
            BufferedOutputStream bos = new BufferedOutputStream(new FileOutputStream(myCaptureFile));
            bm.compress(Bitmap.CompressFormat.JPEG, 80, bos);
            bos.flush();
            bos.close();
            //把图片保存后声明这个广播事件通知系统相册有新图片到来
            Intent intent = new Intent(Intent.ACTION_MEDIA_SCANNER_SCAN_FILE);
            Uri uri = Uri.fromFile(myCaptureFile);
            intent.setData(uri);
            context.sendBroadcast(intent);
        }
    }


    /**
     * 获取Bitmap缓存
     */
    public Bitmap getBitmap() {
        setDrawingCacheEnabled(true);
        buildDrawingCache();
        Bitmap bitmap = getDrawingCache();
        setDrawingCacheEnabled(false);
        return bitmap;
    }

    /**
     * 获取保存路径
     */
    public String getSavePath() {
        return mSavePath;
    }

    /**
     * 逐行扫描，清除边界空白
     *
     * @param blank 边界留多少个像素
     */
    private Bitmap clearBlank(Bitmap bmp, int blank) {
        int height = bmp.getHeight();
        int width = bmp.getWidth();
        int top = 0, left = 0, right = 0, bottom = 0;
        int[] pixs = new int[width];
        boolean isStop;
        //扫描上边距不等于背景颜色的第一个点
        for (int i = 0; i < height; i++) {
            bmp.getPixels(pixs, 0, width, 0, i, width, 1);
            isStop = false;
            for (int pix :
                    pixs) {
                if (pix != BACK_COLOR) {
                    top = i;
                    isStop = true;
                    break;
                }
            }
            if (isStop) {
                break;
            }
        }
        //扫描下边距不等于背景颜色的第一个点
        for (int i = height - 1; i >= 0; i--) {
            bmp.getPixels(pixs, 0, width, 0, i, width, 1);
            isStop = false;
            for (int pix :
                    pixs) {
                if (pix != BACK_COLOR) {
                    bottom = i;
                    isStop = true;
                    break;
                }
            }
            if (isStop) {
                break;
            }
        }
        pixs = new int[height];
        //扫描左边距不等于背景颜色的第一个点
        for (int x = 0; x < width; x++) {
            bmp.getPixels(pixs, 0, 1, x, 0, 1, height);
            isStop = false;
            for (int pix : pixs) {
                if (pix != BACK_COLOR) {
                    left = x;
                    isStop = true;
                    break;
                }
            }
            if (isStop) {
                break;
            }
        }
        //扫描右边距不等于背景颜色的第一个点
        for (int x = width - 1; x > 0; x--) {
            bmp.getPixels(pixs, 0, 1, x, 0, 1, height);
            isStop = false;
            for (int pix : pixs) {
                if (pix != BACK_COLOR) {
                    right = x;
                    isStop = true;
                    break;
                }
            }
            if (isStop) {
                break;
            }
        }
        if (blank < 0) {
            blank = 0;
        }
        //计算加上保留空白距离之后的图像大小
        left = left - blank > 0 ? left - blank : 0;
        top = top - blank > 0 ? top - blank : 0;
        right = right + blank > width - 1 ? width - 1 : right + blank;
        bottom = bottom + blank > height - 1 ? height - 1 : bottom + blank;
        return Bitmap.createBitmap(bmp, left, top, right - left, bottom - top);
    }

    @Override
    protected void onSizeChanged(int w, int h, int oldw, int oldh) {//布局发生变化  重新回去控件大小
        super.onSizeChanged(w, h, oldw, oldh);
        //创建一个空位图，没有色彩，宽高和bitmap2一样
        cacheBitmap = Bitmap.createBitmap(getWidth(), getHeight(), Bitmap.Config.ARGB_8888);
        //用来承载画的内容。
        mCanvas = new Canvas(cacheBitmap);
        //画板颜色
        mCanvas.drawColor(BACK_COLOR);
        isTouched = false;
    }

    @Override
    protected void onDraw(Canvas canvas) {//绘制
        super.onDraw(canvas);
        canvas.drawBitmap(cacheBitmap, 0, 0, mPaint);
        canvas.drawPath(mPath, mPaint);
    }

    @Override
    public boolean onTouchEvent(MotionEvent event) {
        switch (event.getAction()) {
            case MotionEvent.ACTION_DOWN:
                mPenX = event.getX();
                mPenY = event.getY();
                mPath.moveTo(mPenX, mPenY);//不会进行绘制，只用于移动移动画笔。
                return true;
            case MotionEvent.ACTION_MOVE:
                isTouched = true;
                float x = event.getX();
                float y = event.getY();
                float penX = mPenX;
                float penY = mPenY;
                float dx = Math.abs(x - penX);//取绝对值
                float dy = Math.abs(y - penY);
                if (dx >= 3 || dy >= 3) {
                    float cx = (x + penX) / 2;
                    float cy = (y + penY) / 2;
                    mPath.quadTo(penX, penY, cx, cy);
                    mPenX = x;
                    mPenY = y;
                }
                invalidate();
                break;
            case MotionEvent.ACTION_UP:
                mCanvas.drawPath(mPath, mPaint);
                mPath.reset();//清除之前绘制的path
                break;
            default:
                break;
        }

        return super.onTouchEvent(event);
    }
}
